﻿/* This is the GradStudent class which inherits from Student class.
 * See StuDB for full change history
 * It adds tuitionCredit and Faculty Advisor to the student class.
 * 
 * Change History
 * Date         Developer       Description
 * 2020-02-13   marqusa         In-class work on the program, Chuck Costarella
 * through 25
 * 2020-02-27   marqusa         documentation
 */
namespace StudentDB
{
    class GradStudent : Student
    {
       //Auto-implemented properties of TuitionCredit and FacultyAdvisor
        public decimal TuitionCredit { get; set; }

        public string FacultyAdvisor { get; set; }

        //GradStudent constructor inherits from Student constructor,
        //addding the credit and faculty advisor arguments.
        public GradStudent(string first, string last, double gpa, string email, 
                            decimal credit, string advisor)
            : base(first, last, gpa, email)
        {
            TuitionCredit = credit;
            FacultyAdvisor = advisor;
        }

        // conversion to a lamda expression - mechanism of functional programming.
        // lamda operator is "=>" abd reads "goes to"
        // C# calls this an "expression-bodied method"
        // This is only used for one-liners or very simple things.
        public override string ToString() => base.ToString() + $"Credit: {TuitionCredit:C}\n   Fac: {FacultyAdvisor}\n";

        //the overriden method in the base class must be marked "virtual"
        public override string ToStringForOutputFile()
        {
            //Prepend the discriminator to the base student information
            string str = StuDB.GRADSTUDENT + "\n" + base.ToStringForOutputFile();

            // append the "local information"
            str += $"{TuitionCredit}\n";
            str += $"{FacultyAdvisor}\n";

            return str;
        }

        /* This is the "Standard?" way instead of the lamda way.
         * I am just leaving this in here for my reference.
        public override string ToString()
        {
            return base.ToString() + $"Credit: {TuitionCredit:C}\n    Fac: {FacultyAdvisor}\n";
        }
        */
    }
}
